var CyberloafCat = CyberloafCat || {};
CyberloafCat.Layout = CyberloafCat.Layout || {};

const KSJ_BHD_BC_SHOWER_STANDING_X = -500;
const KSJ_BHD_BC_SHOWER_STANDING_Y = 60;

/// MARK: - Layout
CyberloafCat.Layout.Game_CreateLayout = Window_ActorCommand.prototype.create_layout;
Window_ActorCommand.prototype.create_layout = function() {	
    if (this._layout) {this.removeChild(this._layout)};
	this._layout = new Sprite(this._layout_img);
	this._layout.x = REM_BHD_BC_LAY_X;
	this._layout.y = REM_BHD_BC_LAY_Y;
	let poseName = Karryn.poseName;
    switch(poseName) {
        case POSE_SHOWER_STANDING:
            this._layout.x += KSJ_BHD_BC_SHOWER_STANDING_X;
            this._layout.y += KSJ_BHD_BC_SHOWER_STANDING_Y;
        break;
        default:
            return CyberloafCat.Layout.Game_CreateLayout.call(this);
    }
    this.addChild(this._layout);
}

CyberloafCat.Layout.Game_CreateComName = Window_ActorCommand.prototype.create_com_name;
Window_ActorCommand.prototype.create_com_name = function() {	
    if (this._com_name) {this.removeChild(this._com_name)}; 
	this._com_name = new Sprite(new Bitmap(REM_BHD_BC_NAME_WIDTH,REM_BHD_BC_NAME_HEIGHT))
	this._com_name.x = REM_BHD_BC_NAME_X;
	this._com_name.y = REM_BHD_BC_NAME_Y;
	let poseName = Karryn.poseName;
	switch(poseName) {
        case POSE_SHOWER_STANDING:
            this._com_name.x += KSJ_BHD_BC_SHOWER_STANDING_X;
            this._com_name.y += KSJ_BHD_BC_SHOWER_STANDING_Y;
        break;
        default:
            return CyberloafCat.Layout.Game_CreateComName.call(this);
    }

    this._com_name.bitmap.fontSize = REM_BHD_BC_NAME_FONT_SIZE;
	this.addChild(this._com_name);
}

CyberloafCat.Layout.Game_RefreshBitmapCom = Window_ActorCommand.prototype.refresh_bitmap_com;
Window_ActorCommand.prototype.refresh_bitmap_com = function() {
    let poseName = Karryn.poseName;
    switch(poseName) {
        case POSE_SHOWER_STANDING:
        break;
        default:
            return CyberloafCat.Layout.Game_RefreshBitmapCom.call(this);
    }

    for (var i = 0; i < this.maxCom(); i++) {
		this._com_sprites[i].bitmap = this._com_images[i];
		this._com_images.enabled = this.isCommandEnabled(i);
		this._wh[0] = this.width / 2;
		if (this._wh[1] < this._com_sprites[i].bitmap.height) {this._wh[1] = this._com_sprites[i].bitmap.height};			
	};
	for (var i = 0; i < this.maxCom(); i++) {	
		this._com_sprites[i].x = this._wh[0] + REM_BHD_BC_COM_X;
		this._com_sprites[i].y = this._wh[1] + (this._wh[1] * i) + REM_BHD_BC_COM_Y;	
		let poseName = Karryn.poseName;
		switch(poseName) {
            case POSE_SHOWER_STANDING:
                this._com_sprites[i].x += KSJ_BHD_BC_SHOWER_STANDING_X;
                this._com_sprites[i].y += KSJ_BHD_BC_SHOWER_STANDING_Y;
            break;
            default:
            break;
        };
    }
}

CyberloafCat.Layout.Game_RefreshRingCommand = Window_ActorCommand.prototype.refresh_ring_command;
Window_ActorCommand.prototype.refresh_ring_command = function() {
    let poseName = Karryn.poseName;
    switch(poseName) {
        case POSE_SHOWER_STANDING:
        break;
        default:
            return CyberloafCat.Layout.Game_RefreshRingCommand.call(this);
    }

    for (var i = 0; i < this._com_sprites.legth; i++) {
		this._com_sprites[i].visible = false;
	};
	for (var i = 0; i < this.maxCom(); i++) {
    	this.update_ring_command(i,i)
    	this._com_sprites[i].x = this.width / 2 + REM_BHD_BC_COM_X;
    	this._com_sprites[i].y = this.height / 2 + REM_BHD_BC_COM_Y;	
		let poseName = Karryn.poseName;
		switch(poseName) {
            case POSE_SHOWER_STANDING:
                this._com_sprites[i].x += KSJ_BHD_BC_SHOWER_STANDING_X;
                this._com_sprites[i].y += KSJ_BHD_BC_SHOWER_STANDING_Y;
            break;
            default:
            break;
        }
        this._com_sprites[i].visible = true;
        this._com_sprites[i].opacity = 0;
    };
}

CyberloafCat.Layout.Game_UpdatePosition = Window_ActorCommand.prototype.update_position;
Window_ActorCommand.prototype.update_position = function(i) {
    let poseName = Karryn.poseName;
    switch(poseName) {
        case POSE_SHOWER_STANDING:
        break;
        default:
            return CyberloafCat.Layout.Game_UpdatePosition.call(this, i);
    }
    if (this._com_mode_b === 0) {
    	this._np[0] = this._wh[0] + REM_BHD_BC_COM_X + this._side[i][0];
	    this._np[1] = this._wh[1] + (this._wh[1] * i) - this.limit_height() + REM_BHD_BC_COM_Y + this._side[i][1];
		let poseName = Karryn.poseName;
		switch(poseName) {
            case POSE_SHOWER_STANDING:
                this._np[0] += KSJ_BHD_BC_SHOWER_STANDING_X;
                this._np[1] += KSJ_BHD_BC_SHOWER_STANDING_Y;
            break;
            default:
            break;
        }
    } else {
        this.update_ring_command(i,this._index);
    	this._np[0] = (this.width / 2) + this._wh[0] + REM_BHD_BC_COM_X + this._side[i][0];
	    this._np[1] = (this.height / 2) + this._wh[1] + REM_BHD_BC_COM_Y + this._side[i][1];
		let poseName = Karryn.poseName;
		switch(poseName) {
            case POSE_SHOWER_STANDING:
                this._np[0] += KSJ_BHD_BC_SHOWER_STANDING_X;
                this._np[1] += KSJ_BHD_BC_SHOWER_STANDING_Y;
            break;
            default:
            break;
        }
    }
    this._com_sprites[i].x = this.sprite_move_to(this._com_sprites[i].x,this._np[0],this.com_move_speed());
	this._com_sprites[i].y = this.sprite_move_to(this._com_sprites[i].y,this._np[1],this.com_move_speed());
}

CyberloafCat.Layout.Game_SetSpriteBattlePosData = Game_Actor.prototype.setSpriteBattlerPosData;
Game_Actor.prototype.setSpriteBattlerPosData = function(postName) {
    switch(postName) {
        case POSE_SHOWER_STANDING:
            this._sbp_current_x = 0;
            this._sbp_current_y = 0;
        break;
        default:
            return CyberloafCat.Layout.Game_SetSpriteBattlePosData.call(this, postName);
    }
}

CyberloafCat.Layout.Game_UpdateLayoutWindow = Scene_Battle.prototype.updateLayoutWindow;
Scene_Battle.prototype.updateLayoutWindow = function() {
    CyberloafCat.Layout.Game_UpdateLayoutWindow.call(this);
    if (this._skill_layout) {
		if(this._skillWindow.isOpenAndActive()) {
            let stypeId = this._skillWindow._stypeId;
			switch(stypeId) {
                case SKILLTYPE_SHOWER_ID:
                    this._skill_layout_special.visible = true;
                    this._skill_layout_special.opacity = this._skillWindow.contentsOpacity;
                    this._skill_layout.visible = false;
                    this._skill_layout.opacity = 0;
                break;
                default:
                break;
            }
        }
    }
}